import { defineStore } from 'pinia';
import { getAllDict, getDictByCode } from '@/api/modules/system/dict';
import piniaPersistConfig from '@/stores/helper/persist';
import type { DictCustom } from '@/api/types/system/dict';
import { ref } from 'vue';

export const useOptionsStore = defineStore(
  'options',
  () => {
    const isLoaded = ref(false);
    const dictOptions = ref<Record<string, DictCustom[]>>({});

    async function getAllDictList() {
      if (isLoaded.value) return;
      const { data } = await getAllDict();
      // const data = {
      //   "user_tag": [
      //     {
      //       "id": "1001001",
      //       "sysDictTypeId": 1001,
      //       "codeName": "测试用户",
      //       "alias": "",
      //       "sort": 0,
      //       "callbackShowStyle": "info",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户标签",
      //       "sysDictTypeCode": "user_tag",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1001002",
      //       "sysDictTypeId": 1001,
      //       "codeName": "超级管理员",
      //       "alias": "",
      //       "sort": 0,
      //       "callbackShowStyle": "info",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户标签",
      //       "sysDictTypeCode": "user_tag",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1001003",
      //       "sysDictTypeId": 1001,
      //       "codeName": "普通用户",
      //       "alias": "",
      //       "sort": 0,
      //       "callbackShowStyle": "info",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户标签",
      //       "sysDictTypeCode": "user_tag",
      //       "isDynamic": false
      //     }
      //   ],
      //   "grant_type": [
      //     {
      //       "id": "1005001",
      //       "sysDictTypeId": 1005,
      //       "codeName": "密码认证",
      //       "alias": "password",
      //       "sort": 100,
      //       "callbackShowStyle": "success",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权类型",
      //       "sysDictTypeCode": "grant_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1005004",
      //       "sysDictTypeId": 1005,
      //       "codeName": "短信认证",
      //       "alias": "sms",
      //       "sort": 200,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权类型",
      //       "sysDictTypeCode": "grant_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1005002",
      //       "sysDictTypeId": 1005,
      //       "codeName": "小程序认证",
      //       "alias": "applet",
      //       "sort": 300,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权类型",
      //       "sysDictTypeCode": "grant_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1005003",
      //       "sysDictTypeId": 1005,
      //       "codeName": "三方认证",
      //       "alias": "third",
      //       "sort": 400,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权类型",
      //       "sysDictTypeCode": "grant_type",
      //       "isDynamic": false
      //     }
      //   ],
      //   "sys_client_status": [
      //     {
      //       "id": "1003001",
      //       "sysDictTypeId": 1003,
      //       "codeName": "正常",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权状态",
      //       "sysDictTypeCode": "sys_client_status",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1003002",
      //       "sysDictTypeId": 1003,
      //       "codeName": "禁用",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "info",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "授权状态",
      //       "sysDictTypeCode": "sys_client_status",
      //       "isDynamic": false
      //     }
      //   ],
      //   "menu_type": [
      //     {
      //       "id": "1002001",
      //       "sysDictTypeId": 1002,
      //       "codeName": "目录",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "warning",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "菜单类型",
      //       "sysDictTypeCode": "menu_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1002002",
      //       "sysDictTypeId": 1002,
      //       "codeName": "菜单",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "success",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "菜单类型",
      //       "sysDictTypeCode": "menu_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1002003",
      //       "sysDictTypeId": 1002,
      //       "codeName": "按钮",
      //       "alias": "",
      //       "sort": 3,
      //       "callbackShowStyle": "danger",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "菜单类型",
      //       "sysDictTypeCode": "menu_type",
      //       "isDynamic": false
      //     }
      //   ],
      //   "data_scope_relation_type": [
      //     {
      //       "id": "1007001",
      //       "sysDictTypeId": 1007,
      //       "codeName": "部门权限",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限关联类型",
      //       "sysDictTypeCode": "data_scope_relation_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1007002",
      //       "sysDictTypeId": 1007,
      //       "codeName": "个人权限",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限关联类型",
      //       "sysDictTypeCode": "data_scope_relation_type",
      //       "isDynamic": false
      //     }
      //   ],
      //   "device_type": [
      //     {
      //       "id": "1004001",
      //       "sysDictTypeId": 1004,
      //       "codeName": "PC",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "设备类型",
      //       "sysDictTypeCode": "device_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1004002",
      //       "sysDictTypeId": 1004,
      //       "codeName": "小程序",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "设备类型",
      //       "sysDictTypeCode": "device_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1004003",
      //       "sysDictTypeId": 1004,
      //       "codeName": "Androd",
      //       "alias": "",
      //       "sort": 3,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "设备类型",
      //       "sysDictTypeCode": "device_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1004004",
      //       "sysDictTypeId": 1004,
      //       "codeName": "IOS",
      //       "alias": "",
      //       "sort": 4,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "设备类型",
      //       "sysDictTypeCode": "device_type",
      //       "isDynamic": false
      //     }
      //   ],
      //   "dynamic_user_options": [
      //     {
      //       "id": "1",
      //       "sysDictTypeId": "",
      //       "codeName": "系统管理员",
      //       "alias": "admin",
      //       "sort": 1,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     },
      //     {
      //       "id": "2",
      //       "sysDictTypeId": "",
      //       "codeName": "测试用户",
      //       "alias": "user",
      //       "sort": 2,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     },
      //     {
      //       "id": "3",
      //       "sysDictTypeId": "",
      //       "codeName": "测试1-本部及以下",
      //       "alias": "test1",
      //       "sort": 3,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     },
      //     {
      //       "id": "4",
      //       "sysDictTypeId": "",
      //       "codeName": "测试2-仅本部",
      //       "alias": "test2",
      //       "sort": 4,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     },
      //     {
      //       "id": "5",
      //       "sysDictTypeId": "",
      //       "codeName": "测试3-仅本人",
      //       "alias": "test3",
      //       "sort": 5,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     },
      //     {
      //       "id": "6",
      //       "sysDictTypeId": "",
      //       "codeName": "测试4-自定义",
      //       "alias": "test4",
      //       "sort": 6,
      //       "callbackShowStyle": "primary",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "用户信息",
      //       "sysDictTypeCode": "dynamic_user_options",
      //       "isDynamic": true
      //     }
      //   ],
      //   "message_type": [
      //     {
      //       "id": "1008001",
      //       "sysDictTypeId": 1008,
      //       "codeName": "待办",
      //       "alias": "todo",
      //       "sort": 1,
      //       "callbackShowStyle": "warning",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "消息类型",
      //       "sysDictTypeCode": "message_type",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1008002",
      //       "sysDictTypeId": 1008,
      //       "codeName": "消息",
      //       "alias": "msg",
      //       "sort": 2,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "消息类型",
      //       "sysDictTypeCode": "message_type",
      //       "isDynamic": false
      //     }
      //   ],
      //   "account_status": [
      //     {
      //       "id": "1000001",
      //       "sysDictTypeId": 1000,
      //       "codeName": "正常",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "success",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "账户状态",
      //       "sysDictTypeCode": "account_status",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1000002",
      //       "sysDictTypeId": 1000,
      //       "codeName": "禁用",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "info",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "账户状态",
      //       "sysDictTypeCode": "account_status",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1000003",
      //       "sysDictTypeId": 1000,
      //       "codeName": "禁言",
      //       "alias": "",
      //       "sort": 3,
      //       "callbackShowStyle": "info",
      //       "isLock": "F",
      //       "isShow": "T",
      //       "sysDictTypeName": "账户状态",
      //       "sysDictTypeCode": "account_status",
      //       "isDynamic": false
      //     }
      //   ],
      //   "data_scope": [
      //     {
      //       "id": "1006001",
      //       "sysDictTypeId": 1006,
      //       "codeName": "全部",
      //       "alias": "",
      //       "sort": 1,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限",
      //       "sysDictTypeCode": "data_scope",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1006002",
      //       "sysDictTypeId": 1006,
      //       "codeName": "本部门及以下",
      //       "alias": "",
      //       "sort": 2,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限",
      //       "sysDictTypeCode": "data_scope",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1006003",
      //       "sysDictTypeId": 1006,
      //       "codeName": "仅本部门",
      //       "alias": "",
      //       "sort": 3,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限",
      //       "sysDictTypeCode": "data_scope",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1006004",
      //       "sysDictTypeId": 1006,
      //       "codeName": "仅本人",
      //       "alias": "",
      //       "sort": 4,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限",
      //       "sysDictTypeCode": "data_scope",
      //       "isDynamic": false
      //     },
      //     {
      //       "id": "1006005",
      //       "sysDictTypeId": 1006,
      //       "codeName": "自定义",
      //       "alias": "",
      //       "sort": 5,
      //       "callbackShowStyle": "primary",
      //       "isLock": "T",
      //       "isShow": "T",
      //       "sysDictTypeName": "数据权限",
      //       "sysDictTypeCode": "data_scope",
      //       "isDynamic": false
      //     }
      //   ]
      // }
      dictOptions.value = data;
      isLoaded.value = true;
    }

    function getDictOptions(type: string): DictCustom[] {
      return dictOptions.value[type] || [];
    }

    function setReloadOptions() {
      isLoaded.value = false;
    }

    async function getDictByCodes(typeCodes: string[]) {
      const { data } = await getDictByCode({ typeCode: typeCodes });
      typeCodes.forEach(code => {
        dictOptions.value[code] = data[code];
      });
    }

    return {
      isLoaded,
      dictOptions,
      getAllDictList,
      getDictOptions,
      setReloadOptions,
      getDictByCodes
    };
  },
  {
    persist: piniaPersistConfig('options')
  }
);
